-- $Id: DrawingTests.hs,v 1.1 2019/10/30 01:55:21 leavens Exp leavens $
module DrawingTests where
import Drawing
import Testing
import FloatTesting
main = dotests "DrawingTests $Revision: 1.1 $" tests
-- withinPt tests if two points are approximately equal
withinPt :: Point -> String -> Point -> TestCase Point
withinPt = gTest (\(ax,ay) (ex,ey) -> (ax ~=~ ex && ay ~=~ ey))
tests :: [TestCase Point]
tests =
    let -- functions for use in testing, not for you to implement!
        linearup x = (x,x)   -- picture looks like: /
        half x = (x,0.5)     -- picture looks like: --
        lineardown x = (x,1.0-x) -- picture looks like: \
        h x = if x <= 0.3 then (0.3,1-(10/3)*x) -- pic like: H
              else if 0.3 < x && x < 0.6 then (x, 0.5)
                   else (0.6, (10/4)*(x-0.6))
    in [withinPt (get (makeDrawing linearup) 0.0) "~=~" (0.0,0.0)
       ,withinPt (get (makeDrawing linearup) 0.5) "~=~" (0.5,0.5)
       ,withinPt (get (makeDrawing linearup) 1.0) "~=~" (1.0,1.0)
       ,withinPt (get (flipH (makeDrawing linearup)) 0.1) "~=~" (0.9,0.1)
       ,withinPt (get (flipH (makeDrawing linearup)) 0.4) "~=~" (0.6,0.4)
       ,withinPt (get (flipH (makeDrawing linearup)) 1.0) "~=~" (0.0,1.0)
       ,withinPt (get (makeDrawing lineardown) 0.0) "~=~" (0.0,1.0)
       ,withinPt (get (makeDrawing lineardown) 0.5) "~=~" (0.5,0.5)
       ,withinPt (get (makeDrawing lineardown) 1.0) "~=~" (1.0,0.0)
       ,withinPt (get (flipH (makeDrawing lineardown)) 0.0) "~=~" (1.0,1.0)
       ,withinPt (get (flipH (makeDrawing lineardown)) 0.4) "~=~" (0.6,0.6)
       ,withinPt (get (flipH (makeDrawing lineardown)) 1.0) "~=~" (0.0,0.0)
       ,withinPt (get (makeDrawing half) 0.0) "~=~" (0.0,0.5)
       ,withinPt (get (makeDrawing half) 0.5) "~=~" (0.5,0.5)
       ,withinPt (get (makeDrawing half) 1.0) "~=~" (1.0,0.5)
       ,withinPt (get (makeDrawing h) 0.0) "~=~" (0.3,1.0)
       ,withinPt (get (makeDrawing h) 0.15) "~=~" (0.3,0.5)
       ,withinPt (get (makeDrawing h) 0.3) "~=~" (0.3,0.0)
       ,withinPt (get (makeDrawing h) 0.35) "~=~" (0.35,0.5)
       ,withinPt (get (makeDrawing h) 0.55) "~=~" (0.55,0.5)
       ,withinPt (get (makeDrawing h) 0.6) "~=~" (0.6,0.0)
       ,withinPt (get (makeDrawing h) 0.8) "~=~" (0.6,0.5)
       ,withinPt (get (makeDrawing h) 1.0) "~=~" (0.6,1.0)      ]
